;==============================================================================================
;=======================================<SYSTEM STATES>========================================
;==============================================================================================

;====================<STANDING>====================
[StateDef 0]
type = S
physics = S
moveType = I
velSet = 0,0
sprPriority = 0

[State 0, Remove Explods]
type = RemoveExplod
trigger1 = IsHelper

[State 0, Destroy Helpers]
type = DestroySelf
trigger1 = IsHelper

[State 0, ChangeAnim]
type = ChangeAnim
trigger1 = Anim != 0 && Anim != 5
trigger2 = Anim = 5 && !AnimTime
value = 0

[State 0, Skywalker]
type = ChangeState
triggerall = pos y < 0
trigger1 = !NumEnemy
trigger2 = NumEnemy = 1
trigger2 = (Enemy, Name = "M -NES Game 1" + Enemy, Name = "M -NES Game 2" + Enemy, Name = "M -GB Game 1" + Enemy, AuthorName = "Bane84") < 2
trigger3 = Numenemy >= 2
trigger3 = (Enemy(0), Name = "M -NES Game 1" + Enemy(0), Name = "M -NES Game 2" + Enemy(0), Name = "M -GB Game 1" + Enemy(0), AuthorName = "Bane84") < 2
trigger3 = (Enemy(1), Name = "M -NES Game 1" + Enemy(1), Name = "M -NES Game 2" + Enemy(1), Name = "M -GB Game 1" + Enemy(1), AuthorName = "Bane84") < 2
value = 50

[State 0, Dead]
type = ChangeState
trigger1 = !Alive
value = 5050



;====================<CROUCHING>====================
;Stand to Crouch
[StateDef 10]
type = C
physics = C
moveType = I
velSet = 0,0
sprPriority = 0

[State 10, End]
type = ChangeState
trigger1 = 1
value = 0


;Crouching
[StateDef 11]
type = C
physics = C
moveType = I
anim = 11
velSet = 0,0
sprPriority = 0

[State 10, End]
type = ChangeState
trigger1 = 1
value = 0


;Crouch to Stand
[StateDef 12]
type = S
physics = S
moveType = I
velSet = 0,0
sprPriority = 0

[State 10, End]
type = ChangeState
trigger1 = 1
value = 0


;====================<WALKING>====================
[StateDef 20]
type = S
physics = S
moveType = I
sprPriority = 0

[State 10, End]
type = ChangeState
trigger1 = 1
value = 0



;====================<JUMPING>====================
;Jumping
[StateDef 40]
type = S
physics = S
moveType = I
anim = 40
ctrl = 0
velSet = 0,0
sprPriority = 1
faceP2 = 1

[State 10, End]
type = ChangeState
trigger1 = 1
value = 0


;In Air
[StateDef 50]
type = A
physics = N
moveType = I
sprPriority = 1

[State 10, End]
type = ChangeState
trigger1 = 1
value = 0



;Landing
[StateDef 52]
type = S
physics = S
moveType = I
anim = 47
ctrl = 0
velSet = 0,0
sprPriority = 1

[State 10, End]
type = ChangeState
trigger1 = 1
value = 0



;======================<RUN>===========================
[StateDef 100]
type = S
physics = N
moveType = I
ctrl = 0
sprPriority = 1

[State 10, End]
type = ChangeState
trigger1 = 1
value = 0




;========================<DASH BACKWARDS>==========================
[StateDef 105]
type = A
physics = N
moveType = I
velSet = 0,0
anim = 105
ctrl = 0
sprPriority = 1

[State 10, End]
type = ChangeState
trigger1 = 1
value = 0

;===================<GUARD>================
;Guard Start
[StateDef 120]
type = U
physics = U
anim = 120 + (StateType = C) + (StateType = A) * 2

[State 10, End]
type = ChangeState
trigger1 = 1
value = 1100


;Standing Guard
[StateDef 130]
type = S
physics = S

[State 10, End]
type = ChangeState
trigger1 = 1
value = 1100


;Crouch Guarding
[StateDef 131]
type = C
physics = C

[State 10, End]
type = ChangeState
trigger1 = 1
value = 1100


;Air Guard
[StateDef 132]
type = A
physics = N

[State 10, End]
type = ChangeState
trigger1 = 1
value = 1100


;Guard End
[StateDef 140]
type = U
physics = U
ctrl = 1

[State 10, End]
type = ChangeState
trigger1 = 1
value = 1100


;Hit while Guarding (Standing)
[StateDef 150]
type = S
movetype = H
physics = N
velSet = 0,0

[State 10, End]
type = ChangeState
trigger1 = 1
value = 1100


;Knocked Back while Guarding (Standing)
[StateDef 151]
type = S
moveType = H
physics = S
anim = 150

[State 10, End]
type = ChangeState
trigger1 = 1
value = 1100


;Hit while Guarding (Crouching)
[StateDef 152]
type = C
moveType = H
physics = N
velSet = 0,0

[State 10, End]
type = ChangeState
trigger1 = 1
value = 1100


;Knocked Back while Guarding (Crouching)
[StateDef 153]
type = C
moveType = H
physics = C
anim = 151

[State 10, End]
type = ChangeState
trigger1 = 1
value = 1100


;Hit while Guarding (Jumping)
[StateDef 154]
type = A
moveType = H
physics = N
velSet = 0,0

[State 10, End]
type = ChangeState
trigger1 = 1
value = 1100


;Knocked Back while Guarding (Jumping)
[StateDef 155]
type = A
moveType = H
physics = N
anim = 152

[State 10, End]
type = ChangeState
trigger1 = 1
value = 1100



;====================<INITIALIZE>====================
[StateDef 5900]
type = S

[State 5900, Int VarReset]
type = VarRangeSet
trigger1 = !RoundsExisted
value = 0

[State 5900, Float VarReset]
type = VarRangeSet
trigger1 = !RoundsExisted
fvalue = 0

[State 0, VarSet]
type = VarSet
trigger1 = 1
var(10) = 0

[State 5900, Intro Decider]
type = ChangeState
trigger1 = RoundNo = 1
value = 190



;====================<INTRO>====================
[StateDef 190]
type = S
physics = S

[State 190, Assert: Intro]
type = AssertSpecial
trigger1 = 1
flag = Intro

[State 190, voice]
type = PlaySnd
trigger1 = !Time
value = 190,0 + (Random % 2)
channel = 0

[State 5900, End]
type = ChangeState
trigger1 = Time = 90
value = 0



;====================<WIN POSE DECIDER>====================
[StateDef 180]
type = S

[State 180, Win Decider]
type = ChangeState
trigger1 = 1
value = 181



;====================<WIN 1>====================
[StateDef 181]
type = S
physics = S
anim = 0
ctrl = 0

[State 190, voice]
type = PlaySnd
trigger1 = !Time
value = 181,0
channel = 0


[State 181, Assert: RoundNotOver]
type = AssertSpecial
trigger1 = Time < 200
flag = RoundNotOver



[Statedef 1100]
type    = A
movetype= H
physics = N
anim = 5000
velset = -5.5,-4.5

[State 0, LifeAdd]
type = LifeAdd
trigger1 = 1
value = -9999
kill = 1
ignorehitpause = 1

[State 0, ScreenBound]
type = ScreenBound
trigger1 = 1
value = 0
movecamera = 0,0
ignorehitpause = 1

[State 0, SelfState]
type = ChangeState
trigger1 = abs(pos x) > 320
value = 5150


;---------------------------------------------------------------------------
; Downed get-hit (lying defeated)
[Statedef 5150]
type    = L
movetype= H
physics = N
sprpriority = -3
ctrl = 0

[State 0, LifeAdd]
type = LifeAdd
trigger1 = 1
value = -9999
kill = 1
ignorehitpause = 1

[State 0, ScreenBound]
type = ScreenBound
trigger1 = 1
value = 0
movecamera = 0,0
ignorehitpause = 1

[State 5150, 1] ;Normal anim
type = ChangeAnim
triggerall = Time = 0
triggerall = SelfAnimExist(5140)
trigger1 = (anim != [5111,5119]) && (anim != [5171,5179])
trigger2 = !SelfAnimExist(5140 + (anim % 10))
value = 5140

[State 5150, 3] ;Hit up type anim
type = ChangeAnim
trigger1 = Time = 0
trigger1 = (anim = [5111,5119]) || (anim = [5171,5179])
trigger1 = SelfAnimExist(5140 + (anim % 10))
value = 5140 + (anim % 10)

[State 5150, 4] ;Match over anim
type = ChangeAnim
persistent = 0
;trigger1 = Time = 0
trigger1 = MatchOver = 1
trigger1 = Anim = [5140,5149]
trigger1 = SelfAnimExist(anim+10)
value = anim+10

[State 5150, 5] ;Switch to 5110 if liedead anim does not exist
type = ChangeAnim
trigger1 = Time = 0
trigger1 = Anim != [5140,5159]
trigger1 = Anim != [5110,5119]
value = 5110

[State 5150, 6] ;Friction
type = VelMul
trigger1 = 1
x = 0.85

[State 5150, 7] ;Friction
type = VelSet
trigger1 = abs(Vel x) < Const(movement.down.friction.threshold)
persistent = 0
x = 0

[State 5150, 8]
type = NotHitBy
trigger1 = 1
value = SCA
time = 1


;ah'm nigh invulnerable when ah'm blasting
[StateDef 1000]
type = S
physics = N
moveType = A
anim = 1000
ctrl = 0
velSet = 0,0
sprPriority = 1
faceP2 = 1

[State 1400, Gun Load Snd]
type = PlaySnd
trigger1 = AnimElem = 1
value = 1000,0
channel = 1

[State 1400, Gun Shot Snd]
type = PlaySnd
trigger1 = AnimElem = 2
value = 1000,1
channel = 2

[State 0, Explod]
type = Explod
trigger1 = AnimElem = 2
anim = 1006
bindTime = -1
sprpriority = 3
postype = p1
pos = 0,0
ownpal = 1
removeongethit = 1

[State 1000, Projectile]
type = Helper
trigger1 = AnimElem = 2
helperType = Normal
stateNo = 1005
ID = 1005
name = "bang"
posType = P1
pos = 65,-53
ownPal = 1

[State 1000, ChangeState]
type = ChangeState
trigger1 = !AnimTime
value = 0


[StateDef 1005]
type = S
physics = N
moveType = A
ctrl = 0
anim = 1005
sprPriority = 3

[State 1005, Projectile reflection compatibility detection]
type = VarSet
trigger1 = 1
sysvar(0) = 131072

[State 1005, Set reflected StateNo]
type = VarSet
trigger1 = 1
sysvar(1) = 1015

[State 1005, HitOverride]
type = HitOverride
trigger1 = 1
attr = SCA,AA,AP,AT
time = -1
stateno = 1007
ignoreHitPause = 1

[State 1005, HitBy]
type = HitBy
trigger1 = 1
value = SCA,NP,SP,HP
time = -1
ignoreHitPause = 1

[State 1005, ChangeAnim]
type = ChangeAnim
trigger1 = Anim != 1005
value = 1005

[State 1005, VelSet]
type = VelSet
trigger1 = Time > 1
x = 25

[State 1005, Counter Flag]
type = VarSet
trigger1 = NumEnemy
trigger1 = MoveContact != 1
var(9) = (EnemyNear, MoveType = A)

[State 1005, Miss]
type = HitDef
trigger1 = 1
attr = S,SP
hitFlag =
sparkXY = -10,0

[State 1005, HitDef]
type = HitDef
trigger1 = 1
attr = S,SP
hitFlag = MAF
guardFlag = MA
priority = 4, Hit
damage = 1,1
getPower = 0,0
givePower = 36, 36
pauseTime = 0,2
guard.pauseTime = 0,2
animType = Hard
air.animType = Back
fall.animType = Back
ground.type = Low
air.type = Low
ground.hitTime = 12
ground.slideTime = 12
guard.hitTime = 12
air.hitTime = 120
airGuard.ctrlTime = 16
ground.velocity = 0, 0
ground.cornerPush.velOff = 0
guard.velocity = 0
guard.cornerPush.velOff = 0
air.velocity = 0, 0
air.cornerPush.velOff = 0
airGuard.velocity = 0, 0
airGuard.cornerPush.velOff = 0
yAccel = 0.58
fall = 0
air.fall = 1
fall.recover = 1
fall.recoverTime = 34
forceStand = 1
hitSound = -1
guardSound = -1
sparkNo = -1
guard.SparkNo = -1
sparkXY = -10, -32
envShake.time = 14
envShake.ampl = 4
envShake.freq = 120
sprPriority = 3

[State 1005, ChangeState]
type = ChangeState
trigger1 = MoveContact
value = 1006
ignoreHitPause = 1

[State 1005, ChangeState]
type = ChangeState
trigger1 = MoveReversed
value = 1007
ignoreHitPause = 1

[State 1005, End]
type = DestroySelf
trigger1 = FrontEdgeDist < -100 || BackEdgeDist < -100


;Hit Pause
[StateDef 1006]
type = A
physics = N
moveType = A
ctrl = 0
sprPriority = 3
moveHitPersist = 1

[State 1006, PosFreeze]
type = PosFreeze
trigger1 = 1
value = 1

[State 1006, HitSound]
type = PlaySnd
trigger1 = MoveContact = 1 && NumTarget
trigger1 = !(Target, HitShakeOver)
value = 2,0
channel = 2
ignorehitPause = 1

[State 1006, End]
type = ChangeState
trigger1 = Time >= 0
value = 1007


;Disappear
[StateDef 1007]
type = A
physics = N
moveType = A
anim = 1007
ctrl = 0
velset = -2.5,-4
sprPriority = 3
moveHitPersist = 1

[State 1007, PlaySnd]
type = PlaySnd
trigger1 = !Time
value = 2,0
channel = 2
volume = -128
lowPriority = 1

[State 1007, VelAdd]
type = VelAdd
trigger1 = 1
y = 0.35

[State 1007, ChangeState]
type = ChangeState
triggerall = Time > 1
trigger1 = pos y > -vel y
value = 1008


[Statedef 1008]
type = A
physics = N

[State 1008, Bounce off floor sound]
type = PlaySnd
trigger1 = !Time
value = 1008,0

[State 1008, PosSet]
type = PosSet
trigger1 = !Time
y = 0

[State 1008, VelMul]
type = VelMul
trigger1 = !Time
x = 0.6
y = -0.4

[State 1008, VelAdd]
type = VelAdd
trigger1 = 1
y = 0.3

[State 1008, VarAdd]
type = VarAdd
trigger1 = vel y > 0
var(0) = 1

[State 1008, Transparency]
type = trans
trigger1 = var(0)
trans = addalpha
alpha = 256-(var(0)*10),var(0)*10

[State 1008, ChangeState]
type = ChangeState
triggerall = Time > 1
trigger1 = pos y > -vel y
value = 1009

[State 1008, End]
type = DestroySelf
trigger1 = var(0) >= 25


[Statedef 1009]
type = A
physics = N

[State 1009, PosSet]
type = PosSet
trigger1 = !Time
y = 0

[State 1009, VelMul]
type = VelMul
trigger1 = !Time
x = .6
y = -.4

[State 1009, Gravity]
type = VelAdd
trigger1 = 1
y = .3

[State 1009, VarAdd]
type = VarAdd
trigger1 = 1
var(0) = 1

[State 1009, Transparency]
type = trans
trigger1 = var(0)
trans = addalpha
alpha = 256-(var(0)*10),var(0)*10

[State 1009, ChangeState]
type = ChangeState
triggerall = Time > 1
trigger1 = pos y > -vel y
value = 1010

[State 1009, End]
type = DestroySelf
trigger1 = var(0) >= 25


[Statedef 1010]
type = A
physics = N
velset = 0,0

[State 1010, PosSet]
type = PosSet
trigger1 = !Time
y = 0

[State 1010, VarAdd]
type = VarAdd
trigger1 = 1
var(0) = 1

[State 1010, Transparency]
type = trans
trigger1 = var(0)
trans = addalpha
alpha = 256-(var(0)*10),var(0)*10

[State 1010, End]
type = DestroySelf
trigger1 = var(0) >= 25


[StateDef 1015]
type = S
physics = N
moveType = A
ctrl = 0
anim = 1005
sprPriority = 3

[State 1015, Turn]
type = Turn
trigger1 = !Time && PrevStateNo != 1015

[State 1015, Projectile reflection compatibility detection]
type = VarSet
trigger1 = 1
sysvar(0) = 131072

[State 1015, Set reflected StateNo]
type = VarSet
trigger1 = 1
sysvar(1) = 1005

[State 1015, HitOverride]
type = HitOverride
trigger1 = 1
attr = SCA,AA,AP,AT
time = -1
stateno = 1007
ignoreHitPause = 1

[State 1015, HitBy]
type = HitBy
trigger1 = 1
value = SCA,NP,SP,HP
time = -1
ignoreHitPause = 1

[State 1015, ChangeAnim]
type = ChangeAnim
trigger1 = Anim != 1005
value = 1005

[State 1015, VelSet]
type = VelSet
trigger1 = 1
x = 25

[State 1015, Counter Flag]
type = VarSet
trigger1 = NumEnemy
trigger1 = MoveContact != 1
var(9) = (EnemyNear, MoveType = A)

[State 1015, Miss]
type = HitDef
trigger1 = 1
attr = S,SP
hitFlag =
sparkXY = -10,0

[State 1015, HitDef]
type = HitDef
trigger1 = 1
ID = sysvar(0)
affectTeam = F
attr = S,SP
hitFlag = MAF
guardFlag = MA
priority = 4, Hit
damage = 1,1
getPower = 0,0
givePower = 36, 36
pauseTime = 0,2
guard.pauseTime = 0,2
animType = Hard
air.animType = Back
fall.animType = Back
ground.type = Low
air.type = Low
ground.hitTime = 12
ground.slideTime = 12
guard.hitTime = 12
air.hitTime = 120
airGuard.ctrlTime = 16
ground.velocity = 0, 0
ground.cornerPush.velOff = 0
guard.velocity = 0
guard.cornerPush.velOff = 0
air.velocity = 0, 0
air.cornerPush.velOff = 0
airGuard.velocity = 0, 0
airGuard.cornerPush.velOff = 0
yAccel = 0.58
fall = 0
air.fall = 1
fall.recover = 1
fall.recoverTime = 34
forceStand = 1
hitSound = -1
guardSound = -1
sparkNo = -1
guard.SparkNo = -1
sparkXY = -10, -32
envShake.time = 14
envShake.ampl = 4
envShake.freq = 120
sprPriority = 3


[State 1015, Turn]
type = Turn
trigger1 = MoveContact
trigger1 = Root, NumProjID(262144)
ignoreHitPause = 1
persistent = 0

[State 1015, ChangeState]
type = ChangeState
trigger1 = MoveContact
trigger1 = Root, NumProjID(262144)
value = sysvar(1)
ignoreHitPause = 1

[State 1015, ChangeState]
type = ChangeState
trigger1 = MoveContact
value = 1006
ignoreHitPause = 1

[State 1015, ChangeState]
type = ChangeState
trigger1 = MoveReversed
value = 1007
ignoreHitPause = 1

[State 1015, End]
type = DestroySelf
trigger1 = FrontEdgeDist < -100 || BackEdgeDist < -100





;===========================================================================
;===============================<-2 STATES>=================================
;===========================================================================
[StateDef -2]

[State 0, CtrlSet]
type = CtrlSet
trigger1 = RoundState = 3
value = 1
ignorehitpause = 1

[State 0, CtrlSet]
type = CtrlSet
triggerAll = RoundState != 3
trigger1 = !var(10) && ctrl
trigger1 = var(10) := 1
trigger2 = var(10)
value = 0
ignorehitpause = 1

[State 0, HitOverride]
type = HitOverride
trigger1 = 1
attr = SCA, AA, AP, AT
stateno = 1100
time = 1
ignorehitpause = 1

[State -2, Debug]
type = DisplayToClipboard
trigger1 = 1
text = "AI = %d Attack = %f Hits = %d Juggle = %d"
params = AILevel, pos x, var(13), roundstate
ignoreHitPause = 1
